/* $Header: /CVSROOT/debris/cmds/put.c,v 1.1 2005/08/13 22:59:12 tino Exp $
 *
 * DebRIS: DEBian Remote Install Scripter
 * put <offset> <file> {data}
 *
 * $Log: put.c,v $
 * Revision 1.1  2005/08/13 22:59:12  tino
 * additional functions, see ChangeLog
 *
 */

static int
driscmd_put(char *args)
{
  const char	*n;
  long long	pos;
  char		*end;
  int		fd;

  n	= nextarg(&args);
  pos	= strtoull(n, &end, 0);
  if (*end || !*n || pos<0)
    return err("put: debris sends funny offset %s", n);

  if ((fd=open(args, O_CREAT|O_RDWR, 0755))<0)
    return err("put: cannot create %s", args);
  if (lseek(fd, (off_t)pos, SEEK_SET)!=pos)
    return err("put: cannot seek to %lld", pos);
  if (writeall(fd, config.in->buf+config.data, config.in->len-config.data))
    return err("put: cannot write to %s", args);
  if (close(fd))
    return err("put: cannot close %s", args);
  
  return 0;
}
